#include <Xm/MessageB.h>
#include <Xm/RowColumn.h>
#include <Xm/List.h>
#include <Xm/LabelG.h>
#include <Xm/Frame.h>
#include <iostream>
#include <stdlib.h>
#include "global.h"

void u_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        toplevel, dialog, rc, w, dep_w, sort_w;
  Arg           args[5];
  XmStringTable dep_list, sort_list;
  String        *lcol;
  int           item;
  int           rows, cols;
  int           i, j, dep_count, is_sort;

  void sort_ok_cb(Widget, XtPointer, XtPointer);
  void sput_sort(Widget widget, XtPointer client_data, XtPointer call_data);
  void sput_dep(Widget widget, XtPointer client_data, XtPointer call_data);
  void dput_sort(Widget widget, XtPointer client_data, XtPointer call_data);
  void dput_dep(Widget widget, XtPointer client_data, XtPointer call_data);

  /* get various data structurs */
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
  

  item=(int) client_data;
  switch(item) {
  case 0:      // sort by variables;
    i=0;
    XtSetArg(args[i], XmNdialogTitle,
	     XmStringCreateLocalized("Sort by Variables")); i++;
    XtSetArg(args[i], XmNmessageString,
	     XmStringCreateLocalized("select sort variables:")); i++;
    dialog=XmCreateMessageDialog(toplevel, "sortdialog", args, i);
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON));
    XtVaSetValues(dialog, XmNheight, 350, NULL);
    rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, dialog,
			XmNorientation, XmHORIZONTAL,
			NULL);
    /* create dep-list */
    if (cols-sort.nsort>0) {
      dep_list=(XmStringTable) XtMalloc ((cols-sort.nsort) * sizeof(XmString));
      dep_count=0;
      for (i=0; i<cols; i++) {
	is_sort=0;
	for (j=0; j<sort.nsort; j++) {
	  if (i==sort.sort[j]) is_sort=1;
	}
	if (!is_sort) {
	  dep_list[dep_count]=XmStringCreateLocalized(lcol[i]);
	  dep_count++;
	}
      }
    }
    w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
			      XmNshadowType, XmSHADOW_OUT,
			      NULL);
    XtVaCreateManagedWidget("dependent variables", xmLabelGadgetClass, w,
			    XmNchildType, XmFRAME_TITLE_CHILD,
			    XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			    XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			    NULL);
    dep_w=XmCreateScrolledList(w, "deplist", NULL, 0);
    XtVaSetValues(dep_w,
		  XmNchildType, XmFRAME_WORKAREA_CHILD,
		  XmNselectionPolicy, XmSINGLE_SELECT,
		  NULL);
    if (cols-sort.nsort>0) {
      XtVaSetValues(dep_w,
		  XmNitemCount, (cols-sort.nsort),
		  XmNitems, dep_list,
		  NULL);
    }
    XtManageChild(dep_w);
    /* create sort-list */
    if (sort.nsort>0) {
      sort_list=(XmStringTable) XtMalloc (sort.nsort * sizeof(XmString));
      for (i=0; i<sort.nsort; i++) {
	sort_list[i]=XmStringCreateLocalized(lcol[sort.sort[i]]);
      }
    }
    w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
			      XmNshadowType, XmSHADOW_OUT,
			      NULL);
    XtVaCreateManagedWidget("sort variables", xmLabelGadgetClass, w,
			    XmNchildType, XmFRAME_TITLE_CHILD,
			    XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			    XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			    NULL);
    sort_w=XmCreateScrolledList(w,"sortlist", NULL, 0);
    XtVaSetValues(sort_w,
		  XmNchildType, XmFRAME_WORKAREA_CHILD,
		  XmNselectionPolicy, XmSINGLE_SELECT,
		  NULL);
    if (sort.nsort>0) {
      XtVaSetValues(sort_w,
		    XmNitemCount, sort.nsort,
		    XmNitems, sort_list,
		    NULL);
    }
    XtManageChild(sort_w);
    XtManageChild(rc);
    XtManageChild(dialog);
    XtAddCallback(dep_w, XmNsingleSelectionCallback, sput_sort, sort_w);
    XtAddCallback(sort_w, XmNsingleSelectionCallback, sput_dep, dep_w);
    XtAddCallback(dialog, XmNokCallback, sort_ok_cb, NULL);
    XtPopup(XtParent(dialog), XtGrabNone);

    if (cols-sort.nsort > 0) {
      for (i=0; i<(cols-sort.nsort); i++) XmStringFree(dep_list[i]);
      XtFree((char *)dep_list);
    }
    if (sort.nsort > 0) {
      for (i=0; i<sort.nsort; i++) XmStringFree(sort_list[i]);
      XtFree((char *)sort_list);
    }
    break;
  case 1: /* select dependent variables */
    i=0;
    XtSetArg(args[i], XmNdialogTitle,
	     XmStringCreateLocalized("Select Dependent Variables")); i++;
    XtSetArg(args[i], XmNmessageString,
	     XmStringCreateLocalized("select dependent variables:")); i++;
    dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON));
    XtVaSetValues(dialog, XmNheight, 350, NULL);
    rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, dialog,
			XmNorientation, XmHORIZONTAL,
			NULL);
    /* create list of all variables that are not sort and not dependent */
    if (cols-sort.nsort-sort.ndep>0) {
      dep_list=(XmStringTable) XtMalloc ((cols-sort.nsort-sort.ndep) * sizeof(XmString));
      dep_count=0;
      for (i=0; i<cols; i++) {
	is_sort=0;
	for (j=0; j<sort.nsort; j++) if (i==sort.sort[j]) is_sort=1;
	for (j=0; j<sort.ndep;  j++) if (i==sort.dep[j])  is_sort=1;
	if (!is_sort) {
	  dep_list[dep_count]=XmStringCreateLocalized(lcol[i]);
	  dep_count++;
	}
      }
    }
    w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
			      XmNshadowType, XmSHADOW_OUT,
			      NULL);
    dep_w=XmCreateScrolledList(w, "deplist", NULL, 0);
    XtVaCreateManagedWidget("select from", xmLabelGadgetClass, w,
			    XmNchildType, XmFRAME_TITLE_CHILD,
			    XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			    XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			    NULL);
    XtVaSetValues(dep_w,
		  XmNchildType, XmFRAME_WORKAREA_CHILD,
		  XmNselectionPolicy, XmSINGLE_SELECT,
		  NULL);
    if (cols-sort.nsort-sort.ndep>0)
      XtVaSetValues(dep_w,
		    XmNitemCount, (cols-sort.nsort-sort.ndep),
		    XmNitems, dep_list,
		    NULL);

    /* create list of dependent */
    if (sort.ndep>0) {
      sort_list=(XmStringTable) XtMalloc (sort.ndep * sizeof(XmString));
      for (i=0; i<sort.ndep; i++) 
	sort_list[i]=XmStringCreateLocalized(lcol[sort.dep[i]]);
    }
    w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
			      XmNshadowType, XmSHADOW_OUT,
			      NULL);
    XtVaCreateManagedWidget("dependent variables", xmLabelGadgetClass, w,
			    XmNchildType, XmFRAME_TITLE_CHILD,
			    XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			    XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			    NULL);
    sort_w=XmCreateScrolledList(w,"sortlist", NULL, 0);
    XtVaSetValues(sort_w,
		  XmNchildType, XmFRAME_WORKAREA_CHILD,
		  XmNselectionPolicy, XmSINGLE_SELECT,
		  NULL);
    if (sort.ndep>0) 
      XtVaSetValues(sort_w,
		    XmNitemCount, sort.ndep,
		    XmNitems, sort_list,
		    NULL);

    XtManageChild(dep_w);
    XtManageChild(sort_w);
    XtManageChild(rc);
    XtManageChild(dialog);
    XtAddCallback(dep_w, XmNsingleSelectionCallback, dput_sort, sort_w);
    XtAddCallback(sort_w, XmNsingleSelectionCallback, dput_dep, dep_w);
    XtPopup(XtParent(dialog), XtGrabNone);

    if (cols-sort.nsort-sort.ndep > 0) {
      for (i=0; i<(cols-sort.nsort-sort.ndep); i++) XmStringFree(dep_list[i]);
      XtFree((char *)dep_list);
    }
    if (sort.ndep > 0) {
      for (i=0; i<sort.ndep; i++) XmStringFree(sort_list[i]);
      XtFree((char *)sort_list);
    }
    break;
  }
}

/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void sort_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int rows;
  
  extern void sortcells();

  if (sort.nsort > 0) {
    sortcells();
    XbaeMatrixRefresh(StatData);
  }
  else {
    XtVaGetValues(StatData, XmNrows, &rows, NULL);
    sort.ngroup=1;
    sort.group=(int *)realloc(sort.group, sort.ngroup*sizeof(int));
    sort.group[0]=rows;
  }
}

void sput_sort(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               sort_w;
  XmListCallbackStruct *cbs;
  int                  i, cols;
  String               *lcol;
  char                 *text;
  
  sort_w=(Widget) client_data;
  cbs   =(XmListCallbackStruct *) call_data;
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &text);
  for (i=0; i<cols; i++)
    if (!strcmp(text, lcol[i])) sort.add(i);

  XmListAddItem(sort_w, cbs->item, 0);
  XmListDeletePos(widget, cbs->item_position);

  XtFree(text);;
}

void sput_dep(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               dep_w;
  XmListCallbackStruct *cbs;

  dep_w =(Widget) client_data;
  cbs   =(XmListCallbackStruct *) call_data;

  sort.del(cbs->item_position-1);  // list postitions start with 1 and not with 0;

  XmListAddItem(dep_w, cbs->item, 0);
  XmListDeletePos(widget, cbs->item_position);

}

void dput_sort(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               sort_w;
  XmListCallbackStruct *cbs;
  int                  i, cols;
  String               *lcol;
  char                 *text;
  
  sort_w=(Widget) client_data;
  cbs   =(XmListCallbackStruct *) call_data;
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &text);
  for (i=0; i<cols; i++)
    if (!strcmp(text, lcol[i])) sort.adddep(i);

  XmListAddItem(sort_w, cbs->item, 0);
  XmListDeletePos(widget, cbs->item_position);

  XtFree(text);
}

void dput_dep(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               dep_w;
  XmListCallbackStruct *cbs;

  dep_w =(Widget) client_data;
  cbs   =(XmListCallbackStruct *) call_data;
  
  sort.deldep(cbs->item_position-1);  // list postitions start with 1 and not with 0;

  XmListAddItem(dep_w, cbs->item, 0);
  XmListDeletePos(widget, cbs->item_position);
}
